/* ***************************************************************************
   *  Kindermann                                 WPK Produktentwicklung      *
   *                                             Schuljahr: 2016/17          *
   *                                                                         *
   *                                                                         *
   *                Ampelschaltung mit dem Digispark-Board                   *
   *                                                                         *
   *                                                                         *
   *                                                                         *
   ***************************************************************************/



//                       +-\/-+
//  LED (A) grn  PB5   1|    |8   Vcc
//                PB3   2|    |7   PB2   LED (A) gelb
//                PB4   3|    |6   PB1   LED (A) rot
//                GND   4|    |5   PB0
//                       +----+


#ifndef F_CPU
#define F_CPU 16000000UL
#endif

#include <avr/io.h>

// Delay Routine
void delay_ms(unsigned int ms)
  {
  unsigned int zaehler;
  while (ms)
    {
    zaehler = F_CPU / 5000;
    while (zaehler)
      {
      asm volatile ("nop");
      zaehler--;
      }
    ms--;
    }
  }

// Hauptprogramm
int main(void)
  {
  DDRB |= (1 << 1); // PORT B1 output
  DDRB |= (1 << 2); // PORT B2 output
  DDRB |= (1 << 5); // PORT B5 output
  while(1)
    {
    PORTB |= (1<<PORTB1);  // rot ein
    PORTB &= ~(1<<PORTB2); // gelb aus
    PORTB &= ~(1<<PORTB5); // grn aus
    delay_ms(3000);
    PORTB |= (1<<PORTB2);  // gelb ein
    delay_ms(1000);
    PORTB &= ~(1<<PORTB1); // rot aus
    PORTB &= ~(1<<PORTB2); // gelb aus
    PORTB |= (1<<PORTB5);  // grn ein
    delay_ms(3000);
    PORTB |= (1<<PORTB2);  // gelb ein
    PORTB &= ~(1<<PORTB5); // grn aus
    delay_ms(1000);
    }
  }
